@echo Off

If "%1%" == "satorb_en"   goto saturnorbit_enable
If "%1%" == "satorb_dis"  goto saturnorbit_disable
If "%1%" == "mk_init"     goto mk_init
If "%1%" == "mk_cdrom"    goto mk_cdrom
If "%1%" == "mk_libyaul"  goto mk_libyaul
If "%1%" == "mk_sd_alt"   goto mk_sdcard_alt

@echo Error : unknown command !
pause
exit



:saturnorbit_enable
@REM Add SaturnOrbit to environment.
set pathtmp=%path%
set C_INCLUDE_PATH_TMP=%C_INCLUDE_PATH%
set CPLUS_INCLUDE_PATH_TMP=%CPLUS_INCLUDE_PATH%

IF NOT EXIST C:\Saturn~1\SET_ELF.BAT goto satorb_alternate
goto satorb_regular


:satorb_regular
@REM Set SaturnOrbit environment from normal installation directory (C:\SaturnOrbit\)
echo Set SaturnOrbit environment from C:\SaturnOrbit\

@REM In the case SaturnOrbit is installed in C:\SaturnOrbit directory (DEFAULT).

@REM http://vberthelot.free.fr/SX/satdev/SaturnOrbit_r1_setup.exe + http://www.rockin-b.de/windows/saturnorbit/SaturnOrbit_r1_patch.7z
SET LGCC_PATH=C:/SaturnOrbit/SH_elf/sh-elf/lib/gcc/sh-elf/3.4-GNUSH_v0501/

@REM http://vberthelot.free.fr/SaturnOrbit/saturn-orbit-r1-patch2.rar
@REM  *** Requires to changes -m2 to -m1 in the following line ?!?
@REM  *** set flags=-Wall -Werror -m2 %scflags%
set LGCCPATH_TMP=C:/SaturnOrbit/SH_elf/sh-elf/lib/gcc/sh-elf/4.3-GNUSH_v0803/
if exist %LGCCPATH_TMP%libgcc.a SET LGCC_PATH=%LGCCPATH_TMP%

@REM Lastest (4.5-GNUSH_v11.01): http://www.kpitgnutools.com/latestToolchain.php
set LGCCPATH_TMP=C:/SaturnOrbit/SH_elf/sh-elf/lib/gcc/sh-elf/4.5-GNUSH_v11.01/
if exist %LGCCPATH_TMP%libgcc.a SET LGCC_PATH=%LGCCPATH_TMP%

COPY C:\Saturn~1\SET_ELF.BAT .\TMP.BAT
set ip_path=C:/SaturnOrbit/COMMON/IP_GAS/IP_elf.BIN
goto satorb_end



:satorb_alternate
@REM Set SaturnOrbit environment from alternate installation directory (D:\dev\SaturnOrbit\)
@REM Useful when your C: drive is nearly full.
echo Set SaturnOrbit environment from D:\dev\SaturnOrbit\

@REM In the case SaturnOrbit is installed in D:\dev\SaturnOrbit directory.

@REM http://vberthelot.free.fr/SX/satdev/SaturnOrbit_r1_setup.exe + http://www.rockin-b.de/windows/saturnorbit/SaturnOrbit_r1_patch.7z
SET LGCC_PATH=D:/dev/SaturnOrbit/SH_elf/sh-elf/lib/gcc/sh-elf/3.4-GNUSH_v0501/

@REM http://vberthelot.free.fr/SaturnOrbit/saturn-orbit-r1-patch2.rar
@REM  *** Requires to changes -m2 to -m1 in the following line ?!?
@REM  *** set flags=-Wall -Werror -m2 %scflags%
set LGCCPATH_TMP=D:/dev/SaturnOrbit/SH_elf/sh-elf/lib/gcc/sh-elf/4.3-GNUSH_v0803/
if exist %LGCCPATH_TMP%libgcc.a SET LGCC_PATH=%LGCCPATH_TMP%

@REM Lastest (4.5-GNUSH_v11.01): http://www.kpitgnutools.com/latestToolchain.php
set LGCCPATH_TMP=D:/dev/SaturnOrbit/SH_elf/sh-elf/lib/gcc/sh-elf/4.5-GNUSH_v11.01/
if exist %LGCCPATH_TMP%libgcc.a SET LGCC_PATH=%LGCCPATH_TMP%

COPY D:\dev\Saturn~1\SET_ELF.BAT .\TMP.BAT
set ip_path=D:/dev/SaturnOrbit/COMMON/IP_GAS/IP_elf.BIN
goto satorb_end


:satorb_end
echo Path to libgcc.a: %LGCC_PATH%
IF EXIST TMP.BAT CALL TMP.BAT
IF EXIST TMP.BAT DEL TMP.BAT

@REM Save SaturnOrbit environment variables.
set pathtmp_so=%path%
set C_INCLUDE_PATH_SO=%C_INCLUDE_PATH%
set CPLUS_INCLUDE_PATH_SO=%CPLUS_INCLUDE_PATH%
set LGCC_PATH_SO=%LGCC_PATH%

goto end




:saturnorbit_disable
@REM Remove SaturnOrbit from environment (needed, because it interferes with MinGW environment).
set path=%pathtmp%
set C_INCLUDE_PATH=%C_INCLUDE_PATH_TMP%
set CPLUS_INCLUDE_PATH=%CPLUS_INCLUDE_PATH_TMP%
goto end




:mk_init
@REM Initialize defines for use by mk.bat
set SC_AFLAGS=
set SC_CFLAGS=
set SC_LDFLAGS=--strip-all
set SC_GCC=
set SC_ASM=
set SC_LYGCC=
set SC_LYASM=

set SC_GCC=%SC_GCC% ../satcom_lib/sc_common.c
set SC_GCC=%SC_GCC% ../satcom_lib/saturn/sc_saturn.c
set SC_GCC=%SC_GCC% ../satcom_lib/saturn/bget/bget.c




echo [satcom_lib_defs.bat]Added base defs.
goto end



:mk_cdrom
set SBL_DIR=../satcom_lib/saturn/SBL

set SC_CFLAGS=%SC_CFLAGS% -DDEBUG_LIB -DSC_USE_CDROM

set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_bif.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_bio.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_cfs.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_cmn.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_dev.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_drv.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_mbu.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_mdc.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_mfb.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_mls.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_msb.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_mst.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_mwn.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_reg.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_scd.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_sel.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_sub.c
set SC_GCC=%SC_GCC% %SBL_DIR%/CDC/cdc_unk.c

set SC_GCC=%SC_GCC% %SBL_DIR%/DMA/dma_cpu0.c

set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_buf.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_cdb.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_cdc.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_cdf.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_dir.c

set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_mmb.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_mmc.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_mmf.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_sfb.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_sff.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs_trn.c
set SC_GCC=%SC_GCC% %SBL_DIR%/GFS/gfs.c



echo [satcom_lib_defs.bat]Added CDROM defs.
goto end



:mk_libyaul
@REM Add libyaul-related stuff for use by mk.bat
set LYAUL_DIR=../satcom_lib/saturn/libyaul

@REM set SC_AFLAGS=%SC_AFLAGS% --fatal-warnings --isa=sh2 --big --reduce-memory-overheads -I%LYAUL_DIR%/common
set SC_AFLAGS=%SC_AFLAGS% --fatal-warnings -I%LYAUL_DIR%/common

set SC_CFLAGS=%SC_CFLAGS% -DSC_USE_LIBYAUL
@REM set SC_CFLAGS=%SC_CFLAGS% -W -Wall -Wextra -Werror -Wunused-parameter -Wstrict-aliasing
@REM set SC_CFLAGS=%SC_CFLAGS% -ansi -m2 -mb -O2 -fomit-frame-pointer
@REM set SC_CFLAGS=%SC_CFLAGS% -ffast-math -fstrict-aliasing
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/kernel
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/common
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/common/gdb
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/a/cs0/dram-cartridge
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/a/cs0/usb-cartridge
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/a/cs2/cd-block
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/b/scsp
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/b/vdp1
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/b/vdp2
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/cpu
set SC_CFLAGS=%SC_CFLAGS% -I%LYAUL_DIR%/scu/bus/cpu/smpc





set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\lib\memb.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\mm\free.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\mm\free_r.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\mm\malloc.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\mm\malloc_r.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\mm\realloc_r.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\kernel\mm\slob.c
@REM libyaul\kernel\vfs\init.c
@REM libyaul\kernel\vfs\pathname_cache.c
@REM libyaul\kernel\vfs\fs\iso9660\iso9660.c
@REM libyaul\kernel\vfs\fs\romdisk\romdisk.c


@REM libyaul\common\abort.c
@REM libyaul\common\assert.c
@REM libyaul\common\crt0-init.c
@REM libyaul\common\exception_handler.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\common\irq-mux.c
@REM libyaul\common\stack.c
@REM libyaul\common\gdb\gdb.c
@REM libyaul\common\gdb\sh2-704x.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_dma_cpu_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_dma_cpu_level_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_dma_cpu_level_start.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_dma_cpu_level_stop.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_dsp_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_ic_status_get.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_timer_0_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_timer_1_mode_clear.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_timer_1_mode_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\scu_timer_1_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\dram-cartridge\dram-cartridge_area.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\dram-cartridge\dram-cartridge_id.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\dram-cartridge\dram-cartridge_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\dram-cartridge\dram-cartridge_size.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\usb-cartridge\usb-cartridge_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\usb-cartridge\usb-cartridge_read_byte.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\usb-cartridge\usb-cartridge_read_long.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\usb-cartridge\usb-cartridge_send_byte.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\usb-cartridge\usb-cartridge_send_long.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs0\usb-cartridge\usb-cartridge_xchg_byte.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs2\cd-block\cd-block_cmd_abort_file.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs2\cd-block\cd-block_cmd_init_cd_system.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs2\cd-block\cd-block_execute.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\a\cs2\cd-block\cd-block_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\scsp\scsp_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_bpp_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_change_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_erase_coordinates_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_erase_mode_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_erase_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_interlace_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_fbcr_rotate_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_ptmr_plot_draw_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp1\vdp1_ptmr_plot_idle_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_priority_spn_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_bm_format_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_ccc_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_ch_format_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_display_clear.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_display_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_ls_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_mosaic_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_rp_mode_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_scv_x_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_scv_y_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_scrn_vcs_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_blcs_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_display_clear.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_display_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_hblank_in_wait.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_hcount_get.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_vblank_in_irq_get.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_vblank_in_wait.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_vblank_out_irq_get.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_vblank_out_wait.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_tvmd_vcount_get.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_vram_control_get.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\b\vdp2\vdp2_vram_control_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\cpu_dmac_channel_set.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\cpu_dmac_channel_start.c
@REM libyaul\scu\bus\cpu\cpu_dmac_channel_status_get.c // don't compile ?
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\cpu_dmac_channel_stop.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\cpu_ubc_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_init.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_analog_port.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_data.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_digital_port.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_keyboard_port.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_mouse_port.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_parse.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_racing_port.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_raw_port.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_peripheral_system_manger.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_rtc_settime_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_cdoff_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_cdon_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_ckchg320_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_ckchg352_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_intback_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_mshon_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_nmireq_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_resdisa_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_resenab_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_setsmem_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_sndoff_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_sndon_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_sshoff_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_sshon_call.c
set SC_LYGCC=%SC_LYGCC% %LYAUL_DIR%\scu\bus\cpu\smpc\smpc_smc_sysres_call.c




@REM libyaul/common/crt0.S
@REM libyaul/common/exception.S
@REM libyaul/common/bootstrap/ip.S
@REM libyaul/common/gdb/ihr.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/scu_ic_interrupt_get.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/scu_ic_interrupt_set.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/scu_ic_mask_chg.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/scu_ic_mask_get.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/scu_ic_mask_set.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_disable.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_enable.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_interrupt_get.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_interrupt_set.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_mask_get.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_mask_set.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_vector_base_get.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_vector_base_set.S
set SC_LYASM=%SC_LYASM% %LYAUL_DIR%/scu/bus/cpu/cpu_intc_vector_table.S


echo [satcom_lib_defs.bat]Added libyaul defs.
goto end




:mk_sdcard_alt
set SDALT_DIR=../satcom_lib/saturn/rom_code/sdcard_alt_ram

set SC_CFLAGS=%SC_CFLAGS% -DSC_ALT_SDCARD_LIB

set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/cache.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/directory.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/disc.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/fatdir.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/fatfile.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/filetime.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/file_allocation_table.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/lock.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/mem_allocate.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/partition.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/libfat/sdcard_io.c

set SC_GCC=%SC_GCC% %SDALT_DIR%/sdcard_fat.c
set SC_GCC=%SC_GCC% %SDALT_DIR%/sdcard_packet.c

set SC_GCC=%SC_GCC% %SDALT_DIR%/rom_sdcard.c







:end

