
#include "shared.h"


#define BORD_LEFT   1
#define BORD_RIGHT  2
#define BORD_TOP    4
#define BORD_BOTTOM 8


extern unsigned char conio_font[];
void menu_printchar(int x, int y, unsigned short color, char v, unsigned char border_flags, unsigned char border_color)
{
    int r, c;
    volatile unsigned char *bmp = (volatile unsigned char *)VDP2_VRAM;
    unsigned char fg = (color >> 0) & 0xFF;
    unsigned char bg = (color >> 8) & 0xFF;
    unsigned char d;


    for(r = 0; r < 8; r++)
    {
        unsigned char b;
        b = conio_font[v<<3|r];
        for(c = 0; c < 8; c++)
        {
            d = (b & (0x80 >> c)) ? fg : bg;
            //bmp[((y<<3|r)<<10) + (x<<3|c)] = d;
            bmp[((y*10 + r+1)<<10) + (x*10 + c+1)] = d;
        }            
    }


    /* Reset borders. */
    d = bg;
    for(c = 0; c < 10; c++)
    {
        r = 0; bmp[((y*10 + r)<<10) + (x*10 + c)] = d;
        r = 9; bmp[((y*10 + r)<<10) + (x*10 + c)] = d;
    }
    for(r = 0; r < 10; r++)
    {
        c = 0; bmp[((y*10 + r)<<10) + (x*10 + c)] = d;
        c = 9; bmp[((y*10 + r)<<10) + (x*10 + c)] = d;
    }

    /* If needed, display borders. */
    d = border_color;
    for(c = 0; c < 10; c++)
    {
        if(border_flags & BORD_TOP   ) { r = 0; bmp[((y*10 + r)<<10) + (x*10 + c)] = d; }
        if(border_flags & BORD_BOTTOM) { r = 9; bmp[((y*10 + r)<<10) + (x*10 + c)] = d; }
    }
    for(r = 0; r < 10; r++)
    {
        if(border_flags & BORD_LEFT  ) { c = 0; bmp[((y*10 + r)<<10) + (x*10 + c)] = d; }
        if(border_flags & BORD_RIGHT ) { c = 9; bmp[((y*10 + r)<<10) + (x*10 + c)] = d; }
    }
}
void menu_prinstr(int x, int y, int w, unsigned short color, unsigned char border_flags, unsigned char border_color, char* str)
{
    int n = strlen(str);
    int i;
    unsigned char bf;

    for(i=0; i<w; i++)
    {
        char v = (i<n ? str[i] : ' ');
        if(i == 0)
        {
            bf = border_flags & (~BORD_RIGHT);
        }
        else if(i == (w-1))
        {
            bf = border_flags & (~BORD_LEFT);
        }
        else
        {
            bf = border_flags & (~BORD_LEFT) & (~BORD_RIGHT);
        }
        menu_printchar(x+i, y, color, v, bf, border_color);
    }
}


/* Menu default colors. */
unsigned char  _menu_color_border    = COLOR_BLUE;
unsigned short _menu_color_title     = COLOR_BG_FG(COLOR_WHITE, COLOR_RED);
unsigned short _menu_color_selected  = COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK);
unsigned short _menu_color_notselect = COLOR_BG_FG(COLOR_WHITE, COLOR_BLACK);

/* Menu default etc. */
menu_pos_t _default_menu_pos;


void menu_init(void)
{
    _menu_color_border    = COLOR_BLUE;
    _menu_color_title     = COLOR_RED;//COLOR_BG_FG(COLOR_WHITE, COLOR_RED);
    _menu_color_selected  = COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK);
    _menu_color_notselect = COLOR_WHITE;//COLOR_BG_FG(COLOR_WHITE, COLOR_BLACK);

    menu_pos_t p = (menu_pos_t){1/*x0*/, 8/*y0*/, 30/*w*/, 9/*h*/, 1/*cols*/};
    memcpy((void*)(&_default_menu_pos), &p, sizeof(menu_pos_t));
}







void menu_clear_display(menu_pos_t* p)
{
    int x, y;
    for(x=0; x<p->w; x++)
    {
        for(y=0; y<p->h; y++)
        {
            menu_printchar(p->x0+x, p->y0+y, COLOR_WHITE, ' ', 0/*border_flags*/, /*border_color*/COLOR_WHITE);
        }
    }
}


void menu_display_item(menu_pos_t* p, menu_items_t* m, int r, int c, int item_id, int select_item_tag, int items_count, int bord_top, int bord_left)
{
    unsigned short color = _menu_color_notselect;
    if(item_id < items_count)
    {
        color = (m->it[item_id].tag == select_item_tag ? _menu_color_selected : _menu_color_notselect);
        /* Set custom color. */
        if((color == _menu_color_notselect) && (m->it[item_id].color != 0))
        {
            color = m->it[item_id].color;
        }
    }
    unsigned char border_flags = (bord_left ? BORD_LEFT : 0) | (bord_top ? BORD_TOP : 0);
    if(c ==            0 ) border_flags |= BORD_LEFT;
    if(c == (p->cols - 1)) border_flags |= BORD_RIGHT;
    if(r ==            0 ) border_flags |= BORD_TOP;
    if(r == (p->h -    2)) border_flags |= BORD_BOTTOM;
    char* str = "";
    if(item_id < items_count) str = m->it[item_id].message;
    
    menu_prinstr(p->x0 + c*(p->w/p->cols), p->y0+r+1, p->w/p->cols, color, border_flags, _menu_color_border, str);
}
void menu_display_title(menu_pos_t* p, char* title)
{
    int n = strlen(title);
    int offs = (p->w - n) / 2;
    /* Display title in center of menu. */
    menu_prinstr(p->x0, p->y0, p->w, _menu_color_title, BORD_LEFT | BORD_RIGHT | BORD_TOP | BORD_BOTTOM, _menu_color_border, "");
    menu_prinstr(p->x0 + offs, p->y0, p->w - offs, _menu_color_title, BORD_RIGHT | BORD_TOP | BORD_BOTTOM, _menu_color_border, title);
}
void menu_display(menu_pos_t* p, menu_items_t* m, int select_item_tag, int items_count, int* cursor_col, int* cursor_row)
{
    int i, c;
    int bord_top, bord_left;
    *cursor_col = 0;
    *cursor_row = 0;
    for(c=0; c<p->cols; c++)
    {
        for(i=0; i<(p->h-1); i++)
        {
            if(c==0) bord_left = 0;
            else     bord_left = (m->it[i*p->cols + (c-1)].tag != m->it[i*p->cols + c].tag ? 1 : 0);
            if(i==0) bord_top  = 0;
            else     bord_top  = (m->it[(i-1)*p->cols + c].tag != m->it[i*p->cols + c].tag ? 1 : 0);
            menu_display_item(p, m, i/*r*/, c/*cols*/, i*p->cols + c/*item_id*/, select_item_tag, items_count, bord_top, bord_left);
            if(m->it[i*p->cols + c].tag == select_item_tag)
            {
                *cursor_col = c;
                *cursor_row = i;
            }
        }
    }
}


int _list_items_count = 0;
char** _list_items    = NULL;
unsigned char* _list_colors = NULL;
int menu_list_change_page(int page_id, menu_items_t* m, menu_pos_t* p)
{
    int i, n = p->h-1, id;
    int items_count = _list_items_count;
    char** items    = _list_items;
    unsigned char* colors = _list_colors;

    if(page_id < 0) page_id = 0;
    if((page_id+1)*n > (items_count+0))
    {
        if((items_count%n) == 0)
        {
            page_id = items_count/n - 1;
        }
        else
        {
            page_id = items_count/n;
        }
    }

    for(i=0; i<n; i++)
    {
        id = page_id*n + i;
        if(id < items_count)
        {
            m->it[i].message = items[id];
            m->it[i].tag = i+1;
            m->it[i].color = (_list_colors == NULL ? 0 : colors[id]);
        }
        else
        {
            m->it[i].message = "";
            m->it[i].tag = MENU_TAG_DISABLED;
            m->it[i].color = 0;
        }
    }
    m->it[n].message = NULL;
    m->it[n].tag = MENU_TAG_DISABLED;

    return page_id;
}

int _page_id = 0;
int menu_list_start(char* title, int items_count, char** items, unsigned char* items_color, menu_pos_t* p, int* menu_cancel)
{
    int select_item;
    _page_id = 0;
    menu_items_t mitems;
    menu_items_t* m = &mitems;
    _list_items_count = items_count;
    _list_items       = items;
    _list_colors      = items_color;

    if(p == NULL) p = &_default_menu_pos;
    p->cols = 1;

    _page_id = menu_list_change_page(_page_id, m, p);
    select_item = menu_start(title, m, p, 1/*selected_tag*/, menu_cancel);

    select_item = _page_id*(p->h-1) + select_item-1;
    if(select_item >= items_count) select_item = items_count-1;
    if(select_item < 0) select_item = 0;

    return select_item;
}

int menu_start(char* title, menu_items_t* m, menu_pos_t* p, int selected_tag, int* menu_cancel)
{
    int i, j, items_count, n, d;
    int stag = selected_tag;
    int stag_candidate;
    int cursor_col, cursor_row;
    _page_id = 0;
    int menu_cancel_tmp;
    pad_t pad;

    if(p == NULL) p = &_default_menu_pos;
    if(menu_cancel == NULL) menu_cancel = &menu_cancel_tmp;
    if(selected_tag == MENU_TAG_DISABLED) selected_tag = 1;


    *menu_cancel = 0;
    items_count = p->cols * (p->h-1);

    /* Mark blank entries as disabled. */
    for(i=0; i<items_count; i++)
    {
        n = strlen(m->it[i].message);
        d = 1;
        for(j=0; j<n; j++)
        {
            if(m->it[i].message[j] != ' ')
            {
                d = 0;
                break;
            }
        }
        if(d) m->it[i].tag = MENU_TAG_DISABLED;
    }

    //menu_clear_display(p);
    menu_display_title(p, title);
    menu_display(p, m, stag, items_count, &cursor_col, &cursor_row);

    while(1)
    {
        pad_read(&pad);

        if(((pad.new & PAD_A    ) == 0)
        && ((pad.new & PAD_B    ) == 0)
        && ((pad.new & PAD_C    ) == 0)
        && ((pad.new & PAD_START) == 0))
        {
            break;
        }

    }


    for(;;)
    {
        /* SatCom: if needed, transfer data. */
        sc_check();

        /* Wait for V-Blank. */
        wait_vblank_out();
        wait_vblank_in();

        /* Poll joypad */
        pad_read(&pad);


        /* Quit program ? */
        if((pad.new & PAD_A) && (pad.new & PAD_B) && (pad.new & PAD_C) && (pad.new & PAD_START))
        { /* Exit. */
            menu_clear_display(p);
            return MENU_TAG_DISABLED;
        }

        if((pad.delta & PAD_UP  ) || (pad.delta & PAD_DOWN )
        || (pad.delta & PAD_LEFT) || (pad.delta & PAD_RIGHT))
        {
            int tag_max, tag_min;
            int id_start, id_end, id_pitch;
            int f = 1;
            if((pad.delta & PAD_UP) || (pad.delta & PAD_DOWN))
            {
                id_start =        0 * p->cols + cursor_col;
                id_end   = (p->h-1) * p->cols + cursor_col;
                id_pitch = p->cols;
            }
            else
            {
                id_start = cursor_row * p->cols + 0;
                id_end   = cursor_row * p->cols + p->cols;
                id_pitch = 1;
            }


            /* Get tag boundaries. */
            tag_max = m->it[0].tag;
            tag_min = m->it[0].tag;
            for(i=id_start; i<id_end; i+=id_pitch)
            {
                if(m->it[i].tag != MENU_TAG_DISABLED)
                {
                    if(f)
                    {
                        tag_max = m->it[i].tag;
                        tag_min = m->it[i].tag;
                        f=0;
                    }
                    if(m->it[i].tag > tag_max) { tag_max = m->it[i].tag; }
                    if(m->it[i].tag < tag_min) { tag_min = m->it[i].tag; }
                }
            }

            /* Look for the nearest tag. */
            stag_candidate = ((pad.delta & PAD_UP) || (pad.delta & PAD_LEFT) ? tag_min : tag_max);
            for(i=id_start; i<id_end; i+=id_pitch)
            {
                if(m->it[i].tag != MENU_TAG_DISABLED)
                {
                    if((pad.delta & PAD_DOWN) || (pad.delta & PAD_RIGHT))
                    {
                        if((m->it[i].tag > stag) && (m->it[i].tag < stag_candidate))
                        {
                            stag_candidate = m->it[i].tag;
                        }
                    }
                    if((pad.delta & PAD_UP) || (pad.delta & PAD_LEFT))
                    {
                        if((m->it[i].tag < stag) && (m->it[i].tag > stag_candidate))
                        {
                            stag_candidate = m->it[i].tag;
                        }
                    }
                }
            }
            /* No change ? If so go to the opposite tag or the next page. */
            int perform_refresh = 1;
            if(stag_candidate == stag)
            {
                stag_candidate = ((pad.delta & PAD_UP) || (pad.delta & PAD_LEFT) ? tag_max : tag_min);
            }
            /* If needed, refresh display. */
            if((perform_refresh) && (stag_candidate != stag))
            {
                stag = stag_candidate;
                menu_display(p, m, stag, items_count, &cursor_col, &cursor_row);
            }
        }

        if(((pad.new & PAD_A    ) == 0)
        && ((pad.new & PAD_B    ) == 0)
        && ((pad.new & PAD_C    ) == 0)
        && ((pad.new & PAD_START) == 0))
        {
            if(pad.old & PAD_B)
            { /* Cancel. */
                *menu_cancel = 1;
                stag = selected_tag;
                break;
            }
            if((pad.old & PAD_A) || (pad.old & PAD_C) || (pad.old & PAD_START))
            { /* Confirm. */
                break;
            }
        }
    }


    menu_clear_display(p);
    return stag;
}
