
#ifndef _MENU_H_
#define _MENU_H_


#define MENU_TAG_DISABLED 0

typedef struct _menu_item_t {
    char* message;
    int tag;
    unsigned char color; //0: default color
} menu_item_t;
typedef struct _menu_items_t {
    menu_item_t it[90/*lines * cols*/];
} menu_items_t;

typedef struct _menu_pos_t {
    /* Top-left position + sizes. */
    int x0, y0, w, h, cols;
} menu_pos_t;


typedef void (*Fct_menu_callback)(void*);
typedef int (*Fct_menu_change_page_callback)(int, menu_items_t*, menu_pos_t*);


/* Function prototypes */
void menu_init(void);
int menu_list_start(char* title, int items_count, char** items, unsigned char* items_color, menu_pos_t* p, int* menu_cancel);
int menu_start(char* title, menu_items_t* m, menu_pos_t* p, int selected_tag, int* menu_cancel);


#endif /* _MENU_H_ */

