/**
 *  Sega Saturn Action Replay Firmware maker (decompressor)
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/
 *
 *  Based on Saturn FT2232 Transfer Client
 *  By Anders Montonen (http://www.iki.fi/~antime/)
 *  Version 20060318
 *
 *  This program is released into the public domain.
 *  
**/

#include "shared.h"



#include "../mf_address.h"
#include "../../../satcom_lib/sc_compress.h"
#include "../../../satcom_lib/sc_compress.c"

//---------------------------------------------------------------------------------------
int _main(int pad_connected)
{
    if(pad_connected == 2)
    { /* In the case only pad2 connected, load maintenance menu. */
        MaintenanceMenu(pad_connected, 0/*decomp_error*/);
    }

    /* Pointer to the parameters (length, execution start address). */
    unsigned long* params = (unsigned long*)(FC_FLASH_ADDRESS + FC_PARAMS_OFFSET);
    /* Retrieve each parameters. */
    unsigned char* src_adr = (unsigned char*)(FC_FLASH_ADDRESS+FC_DATA_OFFSET);
    unsigned long length   =                 params[FC_PDATALEN_INDEX];
    unsigned char* dst_adr = (unsigned char*)params[FC_EXEADDRS_INDEX];

    /* Decompress target program from ARP to execution area. */
    unsigned long ret = decomp_exec(src_adr, length, dst_adr);
    if(ret == 0)
    { /* Decompression error. */
        MaintenanceMenu(pad_connected, 1/*decomp_error*/);
    }

    /* Execute the target program (-> quit this program).
     * (code scrap from antime's satclient.c, http://www.iki.fi/~antime/)
     */
    void (*pFun)(void);
    pFun = (void(*)(void))dst_adr;
    (*pFun)();

    return 0;
}

