/**
 *  Sega Saturn Action Replay Firmware maker (loader)
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/
 *
 *  Based on Saturn FT2232 Transfer Client
 *  By Anders Montonen (http://www.iki.fi/~antime/)
 *  Version 20060318
 *
 *  This program is released into the public domain.
 *  
**/


static void ExitToMultiplayer(void)
{
    /* Exit to multiplayer. */
    (**(volatile void(**)(void))0x600026C)();
}

#define PDR1  (*(volatile unsigned char *)0x20100075)
#define PDR2  (*(volatile unsigned char *)0x20100077)
#define DDR1  (*(volatile unsigned char *)0x20100079)
#define DDR2  (*(volatile unsigned char *)0x2010007B)
#define IOSEL (*(volatile unsigned char *)0x2010007D)
#define EXLE  (*(volatile unsigned char *)0x2010007F)
static void pad_init(void)
{
    DDR1    = 0x60; /* TH,TR out, TL,D3-D0 in */
    DDR2    = 0x60; /* TH,TR out, TL,D3-D0 in */
    IOSEL   = 0x03; /* Manual mode for both ports */
    EXLE    = 0x00;
}
/**
 * Test pad1 and pad2 status
 * Return value :
 *  0 : no pad connected
 *  1 : pad1     connected, pad2 not connected
 *  2 : pad1 not connected, pad2     connected
 *  3 : pad1     connected, pad2     connected
**/
static int TestPad12Connection(void)
{
    int ret = 3;
    unsigned char temp;
    int count;

    /** Test pad1 **/
    PDR1 = 0x60;
    for(count=0; count < 16; count++)
        asm("nop");
    temp = PDR1;

    if((temp&0x1) != 0x00)
    { /* Pad1 is disconnected. */
        ret -= 1;
    }


    /** Test pad2 **/
    PDR2 = 0x60;
    for(count=0; count < 16; count++)
        asm("nop");
    temp = PDR2;

    if((temp&0x1) != 0x00)
    { /* Pad2 is disconnected. */
        ret -= 2;
    }

    return ret;
}



#include "../mf_address.h"


//---------------------------------------------------------------------------------------
int main(void)
{
    int pad_connect;

    pad_init();
    pad_connect = TestPad12Connection();

    if(pad_connect == 0)
    { /* In the case no pad connected, emergency exit to multiplayer. */
        ExitToMultiplayer();
    }


    /* Copy decompressor to memory. */
    unsigned char* src_adr = (unsigned char*)(FC_FLASH_ADDRESS+FC_DECOMPRESSOR_OFFSET);
    unsigned long length   =                 FC_DECOMPRESSOR_LENGTH;
    unsigned char* dst_adr = (unsigned char*)FC_DECOMPRESSOR_EXEC;

    /* Copy the decompressor program from the ARP to the execution area. */
    unsigned long ret;
    for(ret=0; ret<length; ret++)
    {
        dst_adr[ret] = src_adr[ret];
    }

    /* Execute the target program (-> quit this program).
     * (code scrap from antime's satclient.c, http://www.iki.fi/~antime/)
     */
    void (*pFun)(int);
    pFun = (void(*)(int))dst_adr;
    (*pFun)(pad_connect);

    return 0;
}

