#ifndef _FC_ADDRESS_H_
#define _FC_ADDRESS_H_

/**
 *  Sega Saturn Action Replay Firmware maker
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/
 *
 *  This file describes the data arrangement into the flash memory.
**/


/* Flash memory start address. */
#define FC_FLASH_ADDRESS 0x22000000

/* About firmware data:
 *   CONTENTS    ~~ SIZE     ~~ START OFFSET
 *-----------------------------------------~~~~
 *  IP.BIN       ~~ 3840  B  ~~ 0x0000 (    0)
 *  loader       ~~ 208   B  ~~ 0x0F00 ( 3840)
 *  parameters   ~~ 16    B  ~~ 0x0FD0 ( 4048)
 *  decompressor ~~ 14368 B  ~~ 0x0FE0 ( 4064)
 *  comp. data   ~~ Varies   ~~ 0x4800 (18432)
 */


/* IP.BIN start offset. */
#define FC_IPBIN_OFFSET        0
/* Loader start offset. */
#define FC_LOADER_OFFSET       (FC_IPBIN_OFFSET + 0xF00)
/* Parameters start offset. (Max 4 parameters) */
#define FC_PARAMS_OFFSET       (FC_LOADER_OFFSET + 208)
/* Decompressor start offset. */
#define FC_DECOMPRESSOR_OFFSET (FC_PARAMS_OFFSET + 16)
#define FC_DECOMPRESSOR_LENGTH (14368)
#define FC_DECOMPRESSOR_EXEC   0x002FC000
/* Compressed data start offset. */
#define FC_DATA_OFFSET         (FC_DECOMPRESSOR_OFFSET + FC_DECOMPRESSOR_LENGTH)

/* Parameter 1: input datalen. */
#define FC_PDATALEN_INDEX 0
/* Parameter 2: execution address. */
#define FC_EXEADDRS_INDEX 1
/* Parameter 3: unused. */
/* Parameter 4: unused. */

#endif
