@echo off
set PATH=%PATH%;C:\MinGW\bin


@REM Add SaturnOrbit stuff to environment variables
CALL ..\..\satcom_lib_defs.bat satorb_en


if "%1"=="" goto rebuild
:start
echo --------------------------------------------
echo  Type `e' to exit.
echo  Type `r' to rebuild program.
echo  Type `t' to test program with yabause.
SET /P cm="Command: "

If "%cm%" == "e" exit
If "%cm%" == "r" goto rebuild
If "%cm%" == "t" goto test
%cm%
goto start


:test
REM ..\mkfirm.exe flatcube.bin test.bin -address 0x06004000 -rom_size 256
..\mkfirm.exe sctest.bin test.bin -address 0x06004000 -rom_size 256
dir test.bin
cd yabause
start yabause.exe
cd ..
goto start



:rebuild

REM Use SaturnOrbit environment
echo Compiling mkfirm ...
set path=%pathtmp_so%
set LGCC_PATH=%LGCC_PATH_SO%
set C_INCLUDE_PATH=%C_INCLUDE_PATH_SO%
set CPLUS_INCLUDE_PATH=%CPLUS_INCLUDE_PATH_SO%

@echo Compile loader ...
cd loader
del /Q loader.bin
sh-elf-gcc -Wall -Werror -m2 -Os -fomit-frame-pointer -nostartfiles crt0.S mf_loader.c -Xlinker -T -Xlinker bart.link -o loader.bin
cd ..
if not exist loader\loader.bin goto start



@echo Compile decompressor ...
cd decompressor
set scflags=-Wall -Werror -m2 
set flags=%scflags% -DSC_COMP_DISABLE
set ldflags=-nostartfiles --script bart.lnk -Map main_elf.map

del /Q *.o main_elf.map

sh-elf-as CRT0.S -o CRT0.o
sh-elf-gcc -c mf_decompressor.c -o mf_decompressor.o %flags%

sh-elf-gcc -c conio.c            -o conio.o            %flags%
sh-elf-gcc -c maintenance_menu.c -o maintenance_menu.o %flags%
sh-elf-gcc -c smpc.c             -o smpc.o             %flags%
sh-elf-gcc -c vdp.c              -o vdp.o              %flags%

sh-elf-gcc -c vga_font.c         -o vga_font.o         %flags%

sh-elf-gcc -c ../../../satcom_lib/saturn/rom_code/usb_cartrom/crc.c          -o crc.o          %flags%
sh-elf-gcc -c ../../../satcom_lib/saturn/rom_code/usb_cartrom/usb_dev_cart.c -o usb_dev_cart.o %flags%

REM put vga_font.o a the end of the binary so that even if decompressor is bigger than maximum size, code is kept intact.
sh-elf-ld %ldflags% ./CRT0.o ./mf_decompressor.o ./conio.o ./maintenance_menu.o ./crc.o ./usb_dev_cart.o ./smpc.o ./vdp.o ./vga_font.o -lc %LGCC_PATH%libgcc.a -o decompressor.bin
del /Q *.o main_elf.map

cd ..
if not exist decompressor\decompressor.bin goto start
dir loader\loader.bin decompressor\decompressor.bin



REM Remove SaturnOrbit from environment (needed, because it interferes with MinGW environment).
set path=%pathtmp%
set LGCC_PATH=%LGCC_PATH_TMP%
set C_INCLUDE_PATH=%C_INCLUDE_PATH_TMP%
set CPLUS_INCLUDE_PATH=%CPLUS_INCLUDE_PATH_TMP%


REM ------------------------------------------
REM Mkfirm executable.
echo Compiling mkfirm PC Executable
..\bin2c.exe IP_BIN\ip.bin loader\loader.bin decompressor\decompressor.bin data.c
gcc -c ..\..\satcom_lib\sc_common.c
gcc -c mkfirm.c
gcc -c data.c
gcc -o ..\mkfirm sc_common.o mkfirm.o data.o
del /Q sc_common.o mkfirm.o data.o

if "%1"=="" goto end
goto start

:end
